/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the NotificationsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationsList{}

// NotificationsList struct for NotificationsList
type NotificationsList struct {
	Results []Notification `json:"results"`
	Total int32 `json:"total"`
}

// NewNotificationsList instantiates a new NotificationsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationsList(results []Notification, total int32) *NotificationsList {
	this := NotificationsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewNotificationsListWithDefaults instantiates a new NotificationsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationsListWithDefaults() *NotificationsList {
	this := NotificationsList{}
	return &this
}

// GetResults returns the Results field value
func (o *NotificationsList) GetResults() []Notification {
	if o == nil {
		var ret []Notification
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *NotificationsList) GetResultsOk() ([]Notification, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *NotificationsList) SetResults(v []Notification) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *NotificationsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *NotificationsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *NotificationsList) SetTotal(v int32) {
	o.Total = v
}

func (o NotificationsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableNotificationsList struct {
	value *NotificationsList
	isSet bool
}

func (v NullableNotificationsList) Get() *NotificationsList {
	return v.value
}

func (v *NullableNotificationsList) Set(val *NotificationsList) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationsList) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationsList(val *NotificationsList) *NullableNotificationsList {
	return &NullableNotificationsList{value: val, isSet: true}
}

func (v NullableNotificationsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


